local Chrono_table = require 'maps.chronosphere.table'
local Balance = require 'maps.chronosphere.balance'
local Difficulty = require 'modules.difficulty_vote'
local Rand = require 'maps.chronosphere.random'
local Raffle = require "maps.chronosphere.raffles"
local Public = {}

local math_random = math.random
local math_sqrt = math.sqrt
local math_floor = math.floor

local function check_groups()
  local bitertable = Chrono_table.get_biter_table()
  for index, group in pairs(bitertable.unit_groups) do
    if not group.valid or group.surface.index ~= objective.active_surface_index or #group.members < 1 then
      bitertable.unit_groups[index] = nil
    else
      if group.state == defines.group_state.finished then
        give_orders(group)
      elseif group.state == defines.group_state.gathering and not group.surface.find_non_colliding_position("rocket-silo", group.position, 3, 1) then
      end
    end
  end

end

local function create_attack_group(surface)

end

local function check_group_activity()

end

local function set_biter_raffle_table(surface)
  local bitertable = Chrono_table.get_biter_table()
	local area = {left_top = {-480,  -480}, right_bottom = {480,  480}}
	local biters = surface.find_entities_filtered({type = "unit", force = "enemy", area = area, limit = 100})
	if not biters[1] then return end
	local i = 1
	for key, e in pairs(biters) do
		if key % 5 == 0 then
			bitertable.biter_raffle[i] = e.name
			i = i + 1
		end
	end
  if _DEBUG then game.print("biter raffle set") end
end

function Public.perform_main_attack()
  local objective = Chrono_table.get_table()
  if objective.chronojumps == 0 then return end
  if objective.passivetimer < 60 then return end
	local surface = game.surfaces[objective.active_surface_index]
	create_attack_group(surface)
  if _DEBUG then game.print("sending main attack") end
end

local function prepare_biters()
  local objective = Chrono_table.get_table()
  if objective.chronojumps == 0 then return end
  if objective.passivetimer < 60 then return end
	local surface = game.surfaces[objective.active_surface_index]
  set_biter_raffle_table(surface)
  if _DEBUG then game.print("biters prepared") end
end

function Public.Tick_actions(tick)
  local tick_minute_functions = {

  	[100] = destroy_inactive_biters,
  	[200 + 30 * 0] = prepare_biters,		-- setup for main_attack
  	[300 + 30 * 1] = Public.perform_main_attack,
  	[300 + 30 * 2] = Public.perform_main_attack,
  	[300 + 30 * 3] = Public.perform_main_attack,
  	[300 + 30 * 4] = Public.perform_main_attack,
  	[300 + 30 * 5] = Public.perform_main_attack,	-- call perform_main_attack 7 times on different ticks
  	[400] = send_near_biters_to_objective,
  	[3500] = wake_up_sleepy_groups,
  	--[300] = Ai.rogue_group
  }
  local key = tick % 3600
  if tick_minute_functions[key] then tick_minute_functions[key]() end
end

return Public
